declare('vzoom', {})

vzoom.version = '1.2.1'
vzoom.step = tonumber(gkini.ReadString('vzoom', 'step', 0.666))
vzoom.min = tonumber(gkini.ReadString('vzoom', 'min', 0.3))
vzoom.max = tonumber(gkini.ReadString('vzoom', 'max', 75))
vzoom.info = '\127ffffff'..'vzoom v'..vzoom.version..[[ commands:
Keep in mind this plugin changes FOV value, this means that to zoom very close you need a small FOV value and opposite for zooming out.
/vzoom step <number> - changes by how much plugin will zoom in with each step, default is 0.666, keep in mind the smaller the value the more plugin will zoom in. Values bigger then one will reverse zooming (and/or break it).
/vzoom min <number> - smallest FOV value. Which means biggest zoom. Default is 0.3.
/vzoom max <number> - biggest FOV value. Default is 75 - normal view.
Commands to bind are: vzoom_in, vzoom_out, vzoom_reset. reset sets FOV to maximum value
eg: /bind MWHEELUP vzoom_in]]

function vzoom.ZoomIn()
	local new_fov = Game.GetCVar('fov')*vzoom.step
	if new_fov>=vzoom.min then
		Game.SetCVar('fov', new_fov)
	else
		Game.SetCVar('fov', vzoom.min)
	end
end

function vzoom.ZoomOut()
	local new_fov = Game.GetCVar('fov')/vzoom.step
	if new_fov<=vzoom.max then
		Game.SetCVar('fov', new_fov)
	else
		Game.SetCVar('fov', vzoom.max)
	end
end

function vzoom.cmd(args)
	if not args then
		print(vzoom.info)
	elseif tonumber(args[2]) then
		args[2] = tonumber(args[2])
		if args[1] == 'step' or 'min' or 'max' then 
			vzoom[args[1]] = args[2]
			gkini.WriteString('vzoom', args[1], args[2])
			print(args[1]..' is now '..args[2])
		end
	else
		print(vzoom.info)
	end
end

RegisterUserCommand('vzoom_in', vzoom.ZoomIn)
RegisterUserCommand('vzoom_out', vzoom.ZoomOut)
RegisterUserCommand('vzoom_reset', function() Game.SetCVar('fov', vzoom.max) end)
RegisterUserCommand('vzoom', function(data, args) vzoom.cmd(args) end)